import {locationChangeAction}from'../actions/router.js';import {CALL_HISTORY_METHOD}from'../constants/routes.js';function appendBasename(location, basename) {
    if (typeof location === 'string' && !location.startsWith(basename)) {
        return basename + location;
    }
    if (typeof location === 'object' && !!location.pathname && !location.pathname.startsWith(basename)) {
        return { ...location, pathname: basename + location.pathname };
    }
    return location;
}
const createRouterMiddleware = ({ router, showHistoryAction, basename }) => () => 
// @ts-ignore
(next) => (action) => {
    if (action.type !== CALL_HISTORY_METHOD) {
        return next(action);
    }
    // @ts-ignore
    const method = action.payload.method;
    // @ts-ignore
    const args = action.payload.args;
    console.log('CALL_HISTORY_METHOD', method, args);
    // eslint-disable-next-line default-case
    switch (method) {
        case 'push': {
            let callArgs = args;
            if (basename && args.length > 0) {
                callArgs = [appendBasename(args[0], basename), ...args.slice(1)];
            }
            const [to, state] = callArgs;
            console.log('CALL_HISTORY_METHOD', method, to, state);
            router.navigate(to, { state });
            break;
        }
        case 'replace': {
            let callArgs = args;
            if (basename && args.length > 0) {
                callArgs = [appendBasename(args[0], basename), ...args.slice(1)];
            }
            const [to, state] = callArgs;
            console.log('CALL_HISTORY_METHOD', method, to, state);
            router.navigate(to, { state, replace: true });
            break;
        }
        case 'go':
            router.navigate(...args);
            break;
        case 'back':
        case 'goBack':
            // @ts-ignore
            router.navigate(-1);
            break;
        case 'forward':
        case 'goForward':
            // @ts-ignore
            router.navigate(1);
            break;
    }
    if (showHistoryAction)
        return next(action);
};
const createReduxRouter = ({ store, history, router }) => {
    store.dispatch(locationChangeAction(history.location, history.action));
    // @ts-ignore
    router.subscribe((state) => {
        // @ts-ignore
        if (state.location) {
            // @ts-ignore
            const action = state.historyAction.toLowerCase();
            // @ts-ignore
            const { location } = state;
            // @ts-ignore
            store.dispatch(locationChangeAction(location, action));
        }
    });
};export{createReduxRouter,createRouterMiddleware};//# sourceMappingURL=router.js.map
